using carderby;
using Sandbox;

[Library( "carderby", Title = "Car Derby" )]
public partial class Game : Sandbox.Game
{
	[Net] public Round GameRound { get; set; }

	public static Game Instance
	{
		get => Current as Game;
	}

	public override void ClientJoined( Client cl )
	{
		base.ClientJoined( cl );
		var player = new CPlayer( cl );
		cl.Pawn = player;
		player.Respawn();
	}

	public override void ClientDisconnect( Client cl, NetworkDisconnectionReason reason )
	{
		if (IsServer) {
			CPlayer pl = (CPlayer)cl.Pawn;
			if ( pl.Vehicle != null )
				pl.Vehicle.Delete();
		}
		base.ClientDisconnect( cl, reason );
	}

	public Game()
	{
		if (IsServer)
		{
			_ = new CarDerbyHud();
		}
		GameRound = new Round();
	}

	[Event( "server.tick" )]
	public void OnServerTick()
	{
		GameRound.Tick();
	}

	protected override void OnDestroy()
	{
		base.OnDestroy();
	}

}
