﻿using Sandbox;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace carderby
{ 

	public enum GameState
	{
		START = 0,
		PROCESS = 1,
		END = 2
	}

	public partial class Round : BaseNetworkable
	{
		[Net] public TimeSince timeSince { get; set; } = new TimeSince();
		[Net] public int roundLength { get; set; } = 60 * 3;
		[Net] public int preTime { get; set; } = 10;
		[Net] public GameState gameState { get; set; } = GameState.START;

		public void StartGame()
		{
			gameState = GameState.START;
			timeSince = new TimeSince();
		}

		public void EndGame()
		{
			gameState = GameState.END;
			timeSince = new TimeSince();
		}

		public void Tick()
		{
			switch (gameState)
			{
				case GameState.START:
				{
					if ( preTime - timeSince <= 0)
					{
						gameState = GameState.PROCESS;
						timeSince = 0;
					}
					break;
				}
				case GameState.PROCESS:
				{
					if ( roundLength - timeSince <= 0 )
					{
						gameState = GameState.END;
						timeSince = 0;
					}
					break;
				}
				case GameState.END:
				{
					if ( preTime - timeSince <= 0 )
					{
						gameState = GameState.START;
							foreach ( Client client in Client.All )
							{
								CPlayer player = ((CPlayer)client.Pawn);
								player.Score = 0;
								player.OnKilled();
							}
						timeSince = 0;
					}
					break;
				}
			}
		}

	}
}
