using Sandbox;
using Sandbox.UI;
using Sandbox.UI.Construct;
using System;
using System.Collections.Generic;

public class TopScore : Panel {

    public Label[] PlayerLabels = new Label[5];

    public TopScore() {
    	Add.Label("Top Score", "title");
		for (int i = 0; i < 5; i++) {
			PlayerLabels[i] = Add.Label("Empty");
		}
    }

	public override void Tick()
	{
		var clients = Client.All;
		List<Client> playerList = new List<Client>();
		foreach (var ent in clients) {
			if (ent.Pawn is CPlayer player) {
				playerList.Add(ent);
			}
		}
		playerList.Sort(delegate(Client x, Client y) {
			return ((CPlayer)y.Pawn).Score.CompareTo(((CPlayer)x.Pawn).Score);
		});
		for (int i = 0; i < 5; i++) {
			if (playerList.Count - 1 >= i) {
				PlayerLabels[i].Text = $"{playerList[i].Name} - {((CPlayer)playerList[i].Pawn).Score}";
			}
			else
				PlayerLabels[i].Text = "Empty";
		}
	}

}
