using Sandbox;
using Sandbox.UI;
using Sandbox.UI.Construct;
using System;
using System.Collections.Generic;

public class Winner : Panel {

    public Label PlayerName;
    public Label Scores;

    public Winner() {
    	Add.Label("Winner", "title");
        PlayerName = Add.Label("", "title");
        Scores = Add.Label("");
    }

	public override void Tick()
	{
		Parent.SetClass("winneropen", Game.Instance.GameRound.gameState == carderby.GameState.END);
        Parent.SetClass("winnerclose", Game.Instance.GameRound.gameState != carderby.GameState.END );
        var clients = Client.All;
		List<Client> playerList = new List<Client>();
		foreach (var ent in clients) {
			if (ent.Pawn is CPlayer player ) {
				playerList.Add(ent);
			}
		}
		playerList.Sort(delegate(Client x, Client y) {
			return ((CPlayer)y.Pawn).Score.CompareTo(((CPlayer)x.Pawn).Score);
		});
        if (playerList.Count > 0) {
            PlayerName.Text = playerList[0].Name;
            Scores.Text = $"Score: {((CPlayer)playerList[0].Pawn).Score}";
        }
        else {
            PlayerName.Text = "Unknown";
            Scores.Text = "Score: We don`t know :c";
        }
	}

}
